uniform sampler2D Tex0, Tex1, Tex2;
uniform vec3 lightDir;
uniform vec4 lightColor;

void main (void)
{
	vec3 n, ecPos, l, r;
	float NdotL, RdotE;

	vec4 colorMap = texture2D(Tex0, gl_TexCoord[0].st);
	vec3 normalMap = texture2D(Tex1, gl_TexCoord[0].st).xyz;
	n = normalize(normalMap * 2.0 - 1.0);
	ecPos = texture2D(Tex2, gl_TexCoord[0].st).xyz;
	
	l = normalize(lightDir);
	
	gl_FragColor = vec4(0.0);

	NdotL = max(dot(n, l), 0.0);

	if (NdotL > 0.0) {
		gl_FragColor += lightColor * NdotL;
		r = reflect(-l, n);
		RdotE = max(dot(r, normalize(-ecPos)), 0.0);
		gl_FragColor += vec4(lightColor * pow(RdotE, 16.0));
	}

	gl_FragColor *= colorMap;
}
