varying vec4 position;
varying mat3 tbnMatrix;
varying vec3 positionTS;
varying float blur;
uniform sampler2D Tex0, Tex1;
uniform float Scale, Bias;

void main(void)
{
	vec4 normalMap;
	vec2 TexCoord = gl_TexCoord[0].st;
	vec2 viewTS = normalize(-positionTS).xy;
	// Flip the view vector vertically to match the GL coordinate system
	viewTS.y = -viewTS.y; 

	for(int i = 0; i < 4; i++) {	
		normalMap = texture2D(Tex1, TexCoord);
		float height = normalMap.a * Scale + Bias;
		TexCoord += height * normalMap.z * viewTS;
	}

	gl_FragData[0] = texture2D(Tex0, TexCoord);
	normalMap = texture2D(Tex1, TexCoord);
	vec3 n = normalize(2.0 * normalMap.rgb - 1.0); // decoding normal map
	vec3 normal = n * tbnMatrix; // Matrix after vector (like using transpose)

	gl_FragData[1] = vec4(normalize(normal) * 0.5 + 0.5, blur);
	gl_FragData[2] = position;
}
