attribute vec4 Tangent;
varying vec4 position;
varying mat3 tbnMatrix;
varying vec3 positionTS;
varying float blur;
uniform float focalDistance, focalRange;

void main(void)
{
	position = gl_ModelViewMatrix * gl_Vertex;
	blur = clamp(abs(-position.z - focalDistance) / focalRange, 0.0, 1.0);
	
	vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
	vec3 tangent = normalize(gl_NormalMatrix * Tangent.xyz);
	vec3 binormal = normalize(-Tangent.w * cross(normal, tangent));

   	// column-major matrix
	tbnMatrix = mat3(tangent.x, binormal.x, normal.x,
		tangent.y, binormal.y, normal.y,
		tangent.z, binormal.z, normal.z);
		
	positionTS = (tbnMatrix * position.xyz);

	gl_Position = ftransform();
	gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	gl_TexCoord[1] = gl_TextureMatrix[1] * gl_MultiTexCoord1;
}
